IF 0  ; 
                      Build this template with "CONSOLE ASSEMBLE AND LINK"
ENDIF ; 

    include \masm32\include\masm32rt.inc

    execute PROTO :DWORD,:DWORD,:DWORD,:DWORD
    get_cpu_id_string PROTO :DWORD

  ; 2 equates to control padding between algorithms

    lingo_htodw PROTO :DWORD
    Alex_Short PROTO :DWORD
    Alex_Long PROTO :DWORD
    clive_htodw PROTO :DWORD

    rcnt equ <0>         ; padding count
    padd equ <int 3>     ; padding content

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL pArr  :DWORD
    LOCAL aCnt  :DWORD
    LOCAL hMem  :DWORD
    LOCAL flen  :DWORD
    LOCAL tcnt  :DWORD
    LOCAL lpcn  :DWORD

    LOCAL acnt  :DWORD
    LOCAL lcnt  :DWORD
    LOCAL lcn2  :DWORD
    LOCAL jcn1  :DWORD
    LOCAL dcn1  :DWORD

    LOCAL buffer[260]:BYTE
    LOCAL pbuf  :DWORD

    push ebx
    push esi
    push edi

    mov pbuf, ptr$(buffer)

    invoke get_cpu_id_string,pbuf       ; get the processor string
    mov pbuf, rv(szMonoSpace,pbuf)      ; format it
    print pbuf,13,10                    ; display formatted string


    invoke SetPriorityClass,rv(GetCurrentProcess),HIGH_PRIORITY_CLASS

    .if rv(exist,"hexnum.txt") != 0
      mov hMem, InputFile("hexnum.txt")               ; open source file
      mov flen, ecx
    .else
      print "Run the batch file first",13,10
    .endif

    invoke ltok,hMem,ADDR pArr                      ; tokenise it
    mov aCnt, eax

    print str$(aCnt)," = item count in file",13,10  ; display item count

    mov acnt, 0
    mov lcnt, 0
    mov lcn2, 0
    mov jcn1, 0
    mov dcn1, 0

  REPEAT 4

    print chr$(13,10,13,10)

    fn execute,ADDR htodw,pArr,aCnt,"library htodw"
    add dcn1, eax

    invoke SleepEx,500,0
    cpuid

    fn execute,ADDR Alex_Long,pArr,aCnt,"Alex_Long"
    add lcn2, eax

    invoke SleepEx,500,0
    cpuid

    fn execute,ADDR Alex_Short,pArr,aCnt,"Alex_Short"
    add acnt, eax

    invoke SleepEx,500,0
    cpuid

    fn execute,ADDR lingo_htodw,pArr,aCnt,"lingo_htodw"
    add lcnt, eax

    invoke SleepEx,500,0
    cpuid

    fn execute,ADDR clive_htodw,pArr,aCnt,"clive_htodw"
    add jcn1, eax

    invoke SleepEx,500,0
    cpuid

  ENDM

    shr lcnt, 2
    shr acnt, 2
    shr lcn2, 2
    shr jcn1, 2
    shr dcn1, 2

    print chr$(13,10,13,10)

    print str$(dcn1)," MS library htodw average",13,10
    print str$(acnt)," MS Alex_Short average",13,10
    print str$(lcnt)," MS lingo_htodw average",13,10
    print str$(lcn2)," MS Alex_Long average",13,10
    print str$(jcn1)," MS clive_htodw average",13,10

    print chr$(13,10,13,10)

    free hMem
    free pArr

    invoke SetPriorityClass,rv(GetCurrentProcess),NORMAL_PRIORITY_CLASS

    pop edi
    pop esi
    pop ebx

    ret

main endp

; 

REPEAT rcnt
  padd
ENDM

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

clive_htodw proc lpString:dword

        pop     eax
        pop     edx
        movzx   ecx, byte ptr [edx]
        push    eax
        xor     eax, eax
        push    ebx
        test    ecx, ecx
        je      @2

      @1:
        add     edx, 1
        or      ecx, 020h
        shl     eax, 4
        add     ecx, -060h
        lea     ebx, [ecx+027h]
        cmovb   ebx, ecx
        movzx   ecx, byte ptr [edx]
        lea     eax, [eax+ebx+9]
        test    ecx, ecx
        jnz     @1

      @2:
        pop     ebx

        ret

clive_htodw endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

REPEAT rcnt
  padd
ENDM

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16
Alex_Long proc lpszStr:DWORD

    mov edx,[esp+4]

    @l1:
    movzx ecx,byte ptr [edx]
    test ecx, ecx
    jz @done
    mov eax,[@@table+ecx*4-(30h*4)]

    movzx ecx,byte ptr [edx+1]
    shl eax,4
    test ecx, ecx
    jz @done
    add eax,[@@table+ecx*4-(30h*4)]

    movzx ecx,byte ptr [edx+2]
    shl eax,4
    test ecx, ecx
    jz @done
    add eax,[@@table+ecx*4-(30h*4)]

    movzx ecx,byte ptr [edx+3]
    shl eax,4
    test ecx, ecx
    jz @done
    add eax,[@@table+ecx*4-(30h*4)]

    movzx ecx,byte ptr [edx+4]
    shl eax,4
    test ecx, ecx
    jz @done
    add eax,[@@table+ecx*4-(30h*4)]

    movzx ecx,byte ptr [edx+5]
    shl eax,4
    test ecx, ecx
    jz @done
    add eax,[@@table+ecx*4-(30h*4)]

    movzx ecx,byte ptr [edx+6]
    shl eax,4
    test ecx, ecx
    jz @done
    add eax,[@@table+ecx*4-(30h*4)]

    movzx ecx,byte ptr [edx+7]
    shl eax,4
    test ecx, ecx
    jz @done
    add eax,[@@table+ecx*4-(30h*4)]

    ret 4

  @done:
    shr eax,4
    ret 4

    align 16
  @@table:
    dd 0,1,2,3,4,5,6,7,8,9
    dd 7 dup (-1)
    dd 10,11,12,13,14,15
    dd 26 dup(-1)
    dd 10,11,12,13,14,15
		
Alex_Long endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

REPEAT rcnt
  padd
ENDM

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16
lingo_htodw proc lpString:DWORD

  ; -------------------------------
  ; Lingo long version (decyphered)
  ; -------------------------------

    mov edx, [esp+4]
    push ebx
    mov ebx, [edx]
    xor ecx, ecx 	
    add cl, bl
    jz End1
    mov eax, [l_tbl_8+ecx*4-192] 
    xor ecx, ecx 	
    add cl, bh
    jz End2
    mov edx, [edx+4]
    add eax, [l_tbl_7+ecx*4-192] 
    xor ecx, ecx 	
    shr ebx, 16
    add cl, bl
    jz End3
    add eax, [l_tbl_6+ecx*4-192] 
    xor ecx, ecx 	
    add cl, bh
    jz End4
    add eax, [l_tbl_5+ecx*4-192] 
    xor ecx, ecx 	
    add cl, dl
    jz End5
    add eax, [l_tbl_4+ecx*4-192] 
    xor ecx, ecx 	
    add cl, dh
    jz End6
    add eax, [l_tbl_3+ecx*4-192] 
    pop ebx 
    shr edx, 16
    xor ecx, ecx 	
    add cl, dl
    jz End7
    add eax, [l_tbl_2+ecx*4-192] 
    xor ecx, ecx 	
    add cl, dh
    jz End8
    add eax, [l_tbl_1+ecx*4-192] 
    ret 4

    align 16
  End1:
    pop ebx
    ret  4

    align 16
  End2:
    shr eax, 28
    pop ebx
    ret 4

    align 16
  End3:
    shr eax, 24
    pop ebx
    ret 4

    align 16
  End4:
    shr eax, 20
    pop ebx
    ret 4

    align 16
  End5:
    shr eax, 16
    pop ebx
    ret 4

    align 16
  End6:
    shr eax, 12
    pop ebx
    ret 4

    align 16
  End7:
    shr eax, 8
    ret 4

    align 16
  End8:
    shr eax, 4
    ret 4

lingo_htodw  endp

  align 16
    l_tbl_1 dd 0,1,2,3,4,5,6,7,8,9
          dd 0,0,0,0,0,0,0,0Ah,0Bh,0Ch,0Dh,0Eh,0Fh
          dd 26 Dup(0),0Ah,0Bh,0Ch,0Dh,0Eh,0Fh
  align 16
    l_tbl_2 dd 0,10h,20h,30h,40h,50h,60h,70h,80h,90h
          dd 0,0,0,0,0,0,0,0A0h,0B0h,0C0h,0D0h,0E0h,0F0h
          dd 26 Dup(0),0A0h,0B0h,0C0h,0D0h,0E0h,0F0h
  align 16
    l_tbl_3 dd 0,100h,200h,300h,400h,500h,600h,700h,800h,900h
          dd 0,0,0,0,0,0,0,0A00h,0B00h,0C00h,0D00h,0E00h,0F00h
          dd 26 Dup(0),0A00h,0B00h,0C00h,0D00h,0E00h,0F00h
  align 16
    l_tbl_4 dd 0,1000h,2000h,3000h,4000h,5000h,6000h,7000h,8000h,9000h
          dd 0,0,0,0,0,0,0,0A000h,0B000h,0C000h,0D000h,0E000h,0F000h
          dd 26 Dup(0),0A000h,0B000h,0C000h,0D000h,0E000h,0F000h
  align 16
    l_tbl_5 dd 0,10000h,20000h,30000h,40000h,50000h,60000h,70000h,80000h,90000h
          dd 0,0,0,0,0,0,0,0A0000h,0B0000h,0C0000h,0D0000h,0E0000h,0F0000h
          dd 26 Dup(0),0A0000h, 0B0000h,0C0000h,0D0000h,0E0000h,0F0000h
  align 16
    l_tbl_6 dd 0,100000h,200000h,300000h,400000h,500000h,600000h,700000h,800000h,900000h
          dd 0,0,0,0,0,0,0,0A00000h,0B00000h,0C00000h,0D00000h,0E00000h,0F00000h
          dd 26 Dup(0),0A00000h, 0B00000h,0C00000h,0D00000h,0E00000h,0F00000h
  align 16
    l_tbl_7 dd 0,1000000h,2000000h,3000000h,4000000h,5000000h,6000000h,7000000h,8000000h,9000000h
          dd 0,0,0,0,0,0,0,0A000000h,0B000000h,0C000000h,0D000000h,0E000000h,0F000000h
          dd 26 Dup(0),0A000000h,0B000000h,0C000000h,0D000000h,0E000000h,0F000000h
  align 16
    l_tbl_8 dd 0,10000000h,20000000h,30000000h,40000000h,50000000h,60000000h,70000000h,80000000h,90000000h
          dd 0,0,0,0,0,0,0,0A0000000h,0B0000000h,0C0000000h,0D0000000h,0E0000000h,0F0000000h
          dd 26 Dup(0),0A0000000h,0B0000000h,0C0000000h,0D0000000h,0E0000000h,0F0000000h

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

REPEAT rcnt
  padd
ENDM

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

Alex_Short proc lpszStr:DWORD

    mov edx, [esp+4]
    mov eax, 0
    mov [esp+4], edi
    movzx edi, BYTE PTR [edx]
    movzx ecx, BYTE PTR [edx]
    test ecx, ecx
    jz lbl1

  lbl0:
    and edi, 15
    shr ecx, 6
    add edx, 1
    shl eax, 4
    lea edi, [edi+ecx*8]
    add eax, ecx
    add eax, edi
    movzx ecx, BYTE PTR [edx]
    movzx edi, BYTE PTR [edx]
    test ecx, ecx
    jnz lbl0

  lbl1:
    mov edi, [esp+4]
    ret 4

Alex_Short    endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

get_cpu_id_string proc pBuffer:DWORD

    LOCAL basicinf  :DWORD
    LOCAL extended  :DWORD

    mov eax, 0                                  ; call basic info function
    cpuid
    mov basicinf, eax

    mov eax, 80000000h                          ; call extended info function
    cpuid
    mov extended, eax

    .if extended == 80000004h || extended == 80000008h
      jmp getID
    .endif

    .if basicinf == 00000001h
      cst pBuffer, "i486 or early Pentium Processor"
      ret
    .elseif basicinf == 00000002h
      cst pBuffer, "Pentium Pro, II or Celeron Processor"
      ret
    .elseif basicinf == 00000003h
      cst pBuffer, "Pentium III Processor"
      ret
    .else
      cst pBuffer, "Cannot Identify x86 Processor"
      ret
    .endif

  getID:

    push ebx
    push esi

    mov esi, pBuffer                    ; load buffer address into ESI
   
    mov eax, 80000002h                  ; extended function 2
    cpuid

    mov [esi],    eax                   ; write results to buffer
    mov [esi+4],  ebx
    mov [esi+8],  ecx
    mov [esi+12], edx

    mov eax, 80000003h                  ; extended function 3
    cpuid

    mov [esi+16], eax                   ; write results to buffer
    mov [esi+20], ebx
    mov [esi+24], ecx
    mov [esi+28], edx

    mov eax, 80000004h                  ; extended function 4
    cpuid

    mov [esi+32], eax                   ; write results to buffer
    mov [esi+36], ebx
    mov [esi+40], ecx
    mov [esi+44], edx

    mov [esi+48], DWORD PTR 0           ; terminate result

    pop esi
    pop ebx

    ret

get_cpu_id_string endp

; 

execute proc pAlgo:DWORD,pArr:DWORD,aCnt:DWORD,pTxt:DWORD

    push ebx
    push esi
    push edi

    invoke GetTickCount                 ; start timing
    push eax

    mov ebx, 50                         ; outer loop count

  ; ====================================
  lbl0:
    xor esi, esi                        ; zero the inner loop counter ESI
    mov edi, pArr                       ; load the array address

  ; ------------------------------------
  @@:
    push [edi]                          ; push the string address
    call pAlgo                          ; call the algorithm address

    add edi, 4
    add esi, 1
    cmp esi, aCnt
    jl @B
  ; ------------------------------------

    sub ebx, 1
    test ebx, ebx
    jnz lbl0
  ; ====================================

    invoke GetTickCount                 ; end timing
    pop ecx
    sub eax, ecx
    push eax

    print str$(eax)," ms "
    print pTxt,13,10

    pop eax                             ; return the timing

    pop edi
    pop esi
    pop ebx

    ret

execute endp

; 

end start
